/* Copyright (C) 2013-2014 Patrick Brans.  All rights reserved.
**
** This file is part of BrickStock.
** BrickStock is based heavily on BrickStore (http://www.brickforge.de/software/brickstore/)
** by Robert Griebl, Copyright (C) 2004-2008.
**
** This file may be distributed and/or modified under the terms of the GNU 
** General Public License version 2 as published by the Free Software Foundation 
** and appearing in the file LICENSE.GPL included in the packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://fsf.org/licensing/licenses/gpl.html for GPL licensing information.
*/
#ifndef __CAPPLICATION_H__
#define __CAPPLICATION_H__

#include <qapplication.h>
#include <qstringlist.h>
#include <qevent.h>
#include <qtranslator.h>

class CFrameWork;
class QTranslator;

class CApplication : public QApplication {
	Q_OBJECT

public:
    CApplication ( int argc, char **argv );
	virtual ~CApplication ( );

	void enableEmitOpenDocument ( bool b = true );
	
	QString appName ( ) const;
	QString appVersion ( ) const;
	QString appURL ( ) const;
	QString sysName ( ) const;
	QString sysVersion ( ) const;

public slots:
	void about ( );
    void checkForUpdates ( const QString & ) { checkForUpdates ( ); }
	void checkForUpdates ( );
	void updateTranslations ( );
	void registration ( );

signals:
	void openDocument ( const QString & );

protected:
    virtual bool event ( QEvent *e );
   	
private slots:
	void doEmitOpenDocument ( );
	void demoVersion ( );

private:
	bool initBrickLink ( );
	void exitBrickLink ( );

private:
	QStringList m_files_to_open;
	bool m_enable_emit;

	QTranslator *m_trans_qt;
	QTranslator *m_trans_brickstock;
};

extern CApplication *cApp;

#endif
